import { Point2D, transformPoint2D, } from 'web-util-kit';
import { MTR_LENGTH, } from '../util';
export class Control {
    constructor() {
        this.controlPoints = [
            {
                type: "mtr",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "mt",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "ml",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "mr",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "mb",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "tl",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "tr",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "bl",
                point: new Point2D(),
                visible: true,
            },
            {
                type: "br",
                point: new Point2D(),
                visible: true,
            },
        ];
    }
    calculate(width, height) {
        const mtr = this.controlPoints.find((cp) => cp.type === 'mtr').point;
        const ml = this.controlPoints.find((cp) => cp.type === 'ml').point;
        const mr = this.controlPoints.find((cp) => cp.type === 'mr').point;
        const mt = this.controlPoints.find((cp) => cp.type === 'mt').point;
        const mb = this.controlPoints.find((cp) => cp.type === 'mb').point;
        const tl = this.controlPoints.find((cp) => cp.type === 'tl').point;
        const tr = this.controlPoints.find((cp) => cp.type === 'tr').point;
        const bl = this.controlPoints.find((cp) => cp.type === 'bl').point;
        const br = this.controlPoints.find((cp) => cp.type === 'br').point;
        tl.setXY(-width / 2, -height / 2);
        mt.setXY(0, -height / 2);
        tr.setXY(width / 2, -height / 2);
        mr.setXY(width / 2, 0);
        br.setXY(width / 2, height / 2);
        mb.setXY(0, height / 2);
        bl.setXY(-width / 2, height / 2);
        ml.setXY(-width / 2, 0);
        mtr.setXY(0, -height / 2 - MTR_LENGTH);
    }
    getPoint(type) {
        const ctrPoint = this.controlPoints.find((cp) => cp.type === type);
        if (ctrPoint) {
            return ctrPoint.point;
        }
        return undefined;
    }
    getAllVisiblePoints() {
        return this.controlPoints.filter((cp) => cp.visible);
    }
    findType(pointer, matrix) {
        let controlPoint, type;
        const cps = this.getAllVisiblePoints();
        for (let i = 0; i < cps.length; i++) {
            controlPoint = cps[i].point;
            controlPoint = transformPoint2D(controlPoint, matrix);
            if (pointer.distanceFrom(controlPoint) < 10) {
                type = cps[i].type;
                break;
            }
        }
        return type;
    }
    setVisible() {
    }
    getControlPoints() {
    }
}
