var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { getIdentityMatrix2X3, } from 'web-util-kit';
import { VinciEvent } from '../event';
import { decorators } from 'util-kit';
const { debounce } = decorators;
export class StaticVinciCanvas extends VinciEvent {
    constructor(options) {
        super();
        this._lowerCanvas = document.createElement('canvas');
        this._lowerCtx = this._lowerCanvas.getContext('2d');
        this.width = 500;
        this.height = 400;
        this.viewportTransform = getIdentityMatrix2X3();
        this.shapes = [];
        this.activeShape = null;
        // test
        this.backgroundColor = 'rgba(255, 255, 255, 0)';
    }
    getElement() {
        return this._lowerCanvas;
    }
    getCanvas() {
        return this._lowerCanvas;
    }
    render() {
        this._lowerCtx.clearRect(0, 0, this.width, this.height);
        // test code, remove later
        this._lowerCtx.save();
        this._lowerCtx.fillStyle = this.backgroundColor;
        this._lowerCtx.fillRect(0, 0, this.width, this.height);
        this._lowerCtx.restore();
        // --------
        this.shapes.forEach((item) => {
            item.render(this._lowerCtx, this.viewportTransform);
            item.renderControls(this._lowerCtx, this.viewportTransform);
        });
    }
    requestRender() {
        console.log('render');
        this._lowerCtx.clearRect(0, 0, this.width, this.height);
        // test code, remove later
        this._lowerCtx.save();
        this._lowerCtx.fillStyle = this.backgroundColor;
        this._lowerCtx.fillRect(0, 0, this.width, this.height);
        this._lowerCtx.restore();
        // --------
        this.shapes.forEach((item) => {
            item.render(this._lowerCtx, this.viewportTransform);
            item.renderControls(this._lowerCtx, this.viewportTransform);
        });
    }
    add(obj) {
        // TODO register vinci into shape
        obj.setVinci(this);
        this.shapes.push(obj);
        obj.fire('onAdded');
    }
    discardActiveObject() {
        if (this.activeShape) {
            this.activeShape.fire('onUnSelected');
        }
        this.shapes.forEach((shape) => shape.active = false);
        this.activeShape = null;
    }
    upwardObject(obj, ref) {
        const idx = this.shapes.findIndex((sub) => sub === obj);
        if (idx > -1 && idx < this.shapes.length - 1) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        let refIdx = this.shapes.findIndex((sub) => sub === ref);
        if (refIdx > -1) {
            this.shapes.splice(refIdx + 1, 0, obj);
        }
        else {
            this.shapes.splice(idx + 1, 0, obj);
        }
        this.requestRender();
    }
    downwardObject(obj, ref) {
        const idx = this.shapes.findIndex((sub) => sub === obj);
        if (idx > 0) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        let refIdx = this.shapes.findIndex((sub) => sub === ref);
        if (refIdx > 0) {
            this.shapes.splice(refIdx - 1, 0, obj);
        }
        else {
            this.shapes.splice(idx - 1, 0, obj);
        }
        this.requestRender();
    }
    toFrontObject(obj) {
        const idx = this.shapes.findIndex((sub) => sub === obj);
        if (idx > -1) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        this.shapes.push(obj);
        this.requestRender();
    }
    toBackObject(obj) {
        const idx = this.shapes.findIndex((sub) => sub === obj);
        if (idx > -1) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        this.shapes.unshift(obj);
        this.requestRender();
    }
}
__decorate([
    debounce(0)
], StaticVinciCanvas.prototype, "requestRender", null);
