import { Emitter, Disposable } from 'util-kit';
export class ShapeEvent extends Disposable {
    constructor() {
        super(...arguments);
        this._onAdded = this._register(new Emitter());
        this.onAdded = this._onAdded.event;
        this._onRemoved = this._register(new Emitter());
        this.onRemoved = this._onRemoved.event;
        this._onSelected = this._register(new Emitter());
        this.onSelected = this._onSelected.event;
        this._onUnSelected = this._register(new Emitter());
        this.onUnSelected = this._onUnSelected.event;
        this._onModified = this._register(new Emitter());
        this.onModified = this._onModified.event;
    }
    fire(type) {
        const eventName = `_${type}`;
        if (this[eventName] && this[eventName].fire) {
            this[eventName].fire(this);
        }
    }
}
