var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { ShapeBase } from './shape-base';
import { saveContext, safeMixins } from '../util';
export class Ellipse extends ShapeBase {
    constructor(options) {
        super(options);
        this.type = 'ellipse';
        // shape params: it defines the shape
        this.cx = 0;
        this.cy = 0;
        this.rx = 0;
        this.ry = 0;
        this.fillStyle = 'rgba(0,0,0,0.3)';
        safeMixins(this, options);
        this.normalize(options);
    }
    // dimension change --> shape change
    // from dimensions to shape 
    calcShape() {
        this.rx = this.width / 2;
        this.ry = this.height / 2;
        this.cx = this.left + this.rx;
        this.cy = this.top + this.ry;
    }
    // shape change --> dimension change
    // from shape to dimensions: left, top, width, height
    calcDimensions() {
        this.width = this.rx * 2;
        this.height = this.ry * 2;
        this.left = this.cx - this.rx;
        this.top = this.cy - this.ry;
    }
    render(ctx, vpt) {
        this.path2D = new Path2D();
        this.path2D.ellipse(this.cx - this.translateX, this.cy - this.translateY, this.rx, this.ry, 0, 0, Math.PI * 2);
        ctx.stroke(this.path2D);
        ctx.fill(this.path2D);
    }
}
__decorate([
    saveContext()
], Ellipse.prototype, "render", null);
