var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { ShapeBase } from './shape-base';
import { saveContext, safeMixins } from '../util';
export class Rect extends ShapeBase {
    constructor(options) {
        super(options);
        this.type = 'rect';
        // border-radius
        this.rx = 0;
        this.ry = 0;
        this.fillStyle = 'green';
        safeMixins(this, options);
        // 以 dimension 的属性优先，以此为基准计算 shape
        this.normalize(options);
    }
    // shape defined in svg specification
    set x(val) {
        this.left = val;
    }
    get x() {
        return this.left;
    }
    set y(val) {
        this.top = val;
    }
    get y() {
        return this.top;
    }
    // dimension change --> shape change
    calcShape() { }
    // shape change --> dimension change
    // TODO calculate real dimension: left, top, width, height
    calcDimensions() { }
    render(ctx, vpt) {
        this.path2D = new Path2D();
        this.path2D.rect(this.x - this.translateX, this.y - this.translateY, this.width, this.height);
        ctx.fill(this.path2D);
        ctx.stroke(this.path2D);
    }
}
__decorate([
    saveContext()
], Rect.prototype, "render", null);
