var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { loadFromImage, Point2D, transformPoint2D, invertMatrix2X3, isTransparent, } from 'web-util-kit';
import { saveContext, safeMixins } from '../util';
import { Rect } from './rect';
export class Source extends Rect {
    constructor(options) {
        super(options);
        this.type = 'source';
        this.originalWidth = 0;
        this.originalHeight = 0;
        this._cacheCanvas = document.createElement('canvas');
        this._cacheCtx = this._cacheCanvas.getContext('2d');
        safeMixins(this, options);
        this.normalize(options);
    }
    async loadFromSource(source) {
        if (source instanceof HTMLImageElement) {
            this.source = await loadFromImage(source);
            this.width = this.source.width;
            this.height = this.source.height;
            this.originalWidth = this.source.width;
            this.originalHeight = this.source.height;
            this._cacheCanvas.width = this.source.width;
            this._cacheCanvas.height = this.source.height;
            this._cacheCtx.drawImage(this.source, 0, 0);
        }
        if (source instanceof HTMLCanvasElement) {
            this.source = source;
            this.width = this.source.width;
            this.height = this.source.height;
            this.originalWidth = this.source.width;
            this.originalHeight = this.source.height;
            this._cacheCanvas.width = this.source.width;
            this._cacheCanvas.height = this.source.height;
            this._cacheCtx.drawImage(this.source, 0, 0);
        }
    }
    render(ctx, vpt) {
        if (!this.source) {
            return;
        }
        ctx.drawImage(this._cacheCanvas, 0, 0, this._cacheCanvas.width, this._cacheCanvas.height, this.x - this.translateX, this.y - this.translateY, this.width, this.height);
        this.path2D = new Path2D();
        this.path2D.rect(this.x - this.translateX, this.y - this.translateY, this.width, this.height);
    }
    isPointInPath(ctx, point) {
        if (!ctx.isPointInPath(this.path2D, point.x, point.y)) {
            return false;
        }
        const inverseMatrix = invertMatrix2X3(this.getTransformMatrix2X3Array());
        const realPointer = transformPoint2D(point, inverseMatrix).addSelf(new Point2D(this.translateX - this.x, this.translateY - this.y));
        realPointer.setX(realPointer.x * this.originalWidth / this.width);
        realPointer.setY(realPointer.y * this.originalHeight / this.height);
        console.log(realPointer.x, realPointer.y, this.width, this.height, this.scaleX, this.scaleY);
        if (isTransparent(this._cacheCtx, realPointer.x, realPointer.y, 1)) {
            return false;
        }
        return true;
    }
}
__decorate([
    saveContext()
], Source.prototype, "render", null);
__decorate([
    saveContext()
], Source.prototype, "isPointInPath", null);
