"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Control = void 0;
var web_util_kit_1 = require("web-util-kit");
var util_1 = require("../util");
var Control = /** @class */ (function () {
    function Control() {
        this.controlPoints = [
            {
                type: "mtr",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "mt",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "ml",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "mr",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "mb",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "tl",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "tr",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "bl",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
            {
                type: "br",
                point: new web_util_kit_1.Point2D(),
                visible: true,
            },
        ];
    }
    Control.prototype.calculate = function (width, height) {
        var mtr = this.controlPoints.find(function (cp) { return cp.type === 'mtr'; }).point;
        var ml = this.controlPoints.find(function (cp) { return cp.type === 'ml'; }).point;
        var mr = this.controlPoints.find(function (cp) { return cp.type === 'mr'; }).point;
        var mt = this.controlPoints.find(function (cp) { return cp.type === 'mt'; }).point;
        var mb = this.controlPoints.find(function (cp) { return cp.type === 'mb'; }).point;
        var tl = this.controlPoints.find(function (cp) { return cp.type === 'tl'; }).point;
        var tr = this.controlPoints.find(function (cp) { return cp.type === 'tr'; }).point;
        var bl = this.controlPoints.find(function (cp) { return cp.type === 'bl'; }).point;
        var br = this.controlPoints.find(function (cp) { return cp.type === 'br'; }).point;
        tl.setXY(-width / 2, -height / 2);
        mt.setXY(0, -height / 2);
        tr.setXY(width / 2, -height / 2);
        mr.setXY(width / 2, 0);
        br.setXY(width / 2, height / 2);
        mb.setXY(0, height / 2);
        bl.setXY(-width / 2, height / 2);
        ml.setXY(-width / 2, 0);
        mtr.setXY(0, -height / 2 - util_1.MTR_LENGTH);
    };
    Control.prototype.getPoint = function (type) {
        var ctrPoint = this.controlPoints.find(function (cp) { return cp.type === type; });
        if (ctrPoint) {
            return ctrPoint.point;
        }
        return undefined;
    };
    Control.prototype.getAllVisiblePoints = function () {
        return this.controlPoints.filter(function (cp) { return cp.visible; });
    };
    Control.prototype.findType = function (pointer, matrix) {
        var controlPoint, type;
        var cps = this.getAllVisiblePoints();
        for (var i = 0; i < cps.length; i++) {
            controlPoint = cps[i].point;
            controlPoint = web_util_kit_1.transformPoint2D(controlPoint, matrix);
            if (pointer.distanceFrom(controlPoint) < 10) {
                type = cps[i].type;
                break;
            }
        }
        return type;
    };
    Control.prototype.setVisible = function () {
    };
    Control.prototype.getControlPoints = function () {
    };
    return Control;
}());
exports.Control = Control;
