"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StaticVinciCanvas = void 0;
var web_util_kit_1 = require("web-util-kit");
var event_1 = require("../event");
var util_kit_1 = require("util-kit");
var debounce = util_kit_1.decorators.debounce;
var StaticVinciCanvas = /** @class */ (function (_super) {
    __extends(StaticVinciCanvas, _super);
    function StaticVinciCanvas(options) {
        var _this = _super.call(this) || this;
        _this._lowerCanvas = document.createElement('canvas');
        _this._lowerCtx = _this._lowerCanvas.getContext('2d');
        _this.width = 500;
        _this.height = 400;
        _this.viewportTransform = web_util_kit_1.getIdentityMatrix2X3();
        _this.shapes = [];
        _this.activeShape = null;
        // test
        _this.backgroundColor = 'rgba(255, 255, 255, 0)';
        return _this;
    }
    StaticVinciCanvas.prototype.getElement = function () {
        return this._lowerCanvas;
    };
    StaticVinciCanvas.prototype.getCanvas = function () {
        return this._lowerCanvas;
    };
    StaticVinciCanvas.prototype.render = function () {
        var _this = this;
        this._lowerCtx.clearRect(0, 0, this.width, this.height);
        // test code, remove later
        this._lowerCtx.save();
        this._lowerCtx.fillStyle = this.backgroundColor;
        this._lowerCtx.fillRect(0, 0, this.width, this.height);
        this._lowerCtx.restore();
        // --------
        this.shapes.forEach(function (item) {
            item.render(_this._lowerCtx, _this.viewportTransform);
            item.renderControls(_this._lowerCtx, _this.viewportTransform);
        });
    };
    StaticVinciCanvas.prototype.requestRender = function () {
        var _this = this;
        console.log('render');
        this._lowerCtx.clearRect(0, 0, this.width, this.height);
        // test code, remove later
        this._lowerCtx.save();
        this._lowerCtx.fillStyle = this.backgroundColor;
        this._lowerCtx.fillRect(0, 0, this.width, this.height);
        this._lowerCtx.restore();
        // --------
        this.shapes.forEach(function (item) {
            item.render(_this._lowerCtx, _this.viewportTransform);
            item.renderControls(_this._lowerCtx, _this.viewportTransform);
        });
    };
    StaticVinciCanvas.prototype.add = function (obj) {
        // TODO register vinci into shape
        obj.setVinci(this);
        this.shapes.push(obj);
        obj.fire('onAdded');
    };
    StaticVinciCanvas.prototype.discardActiveObject = function () {
        if (this.activeShape) {
            this.activeShape.fire('onUnSelected');
        }
        this.shapes.forEach(function (shape) { return shape.active = false; });
        this.activeShape = null;
    };
    StaticVinciCanvas.prototype.upwardObject = function (obj, ref) {
        var idx = this.shapes.findIndex(function (sub) { return sub === obj; });
        if (idx > -1 && idx < this.shapes.length - 1) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        var refIdx = this.shapes.findIndex(function (sub) { return sub === ref; });
        if (refIdx > -1) {
            this.shapes.splice(refIdx + 1, 0, obj);
        }
        else {
            this.shapes.splice(idx + 1, 0, obj);
        }
        this.requestRender();
    };
    StaticVinciCanvas.prototype.downwardObject = function (obj, ref) {
        var idx = this.shapes.findIndex(function (sub) { return sub === obj; });
        if (idx > 0) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        var refIdx = this.shapes.findIndex(function (sub) { return sub === ref; });
        if (refIdx > 0) {
            this.shapes.splice(refIdx - 1, 0, obj);
        }
        else {
            this.shapes.splice(idx - 1, 0, obj);
        }
        this.requestRender();
    };
    StaticVinciCanvas.prototype.toFrontObject = function (obj) {
        var idx = this.shapes.findIndex(function (sub) { return sub === obj; });
        if (idx > -1) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        this.shapes.push(obj);
        this.requestRender();
    };
    StaticVinciCanvas.prototype.toBackObject = function (obj) {
        var idx = this.shapes.findIndex(function (sub) { return sub === obj; });
        if (idx > -1) {
            this.shapes.splice(idx, 1);
        }
        else {
            return;
        }
        this.shapes.unshift(obj);
        this.requestRender();
    };
    __decorate([
        debounce(0)
    ], StaticVinciCanvas.prototype, "requestRender", null);
    return StaticVinciCanvas;
}(event_1.VinciEvent));
exports.StaticVinciCanvas = StaticVinciCanvas;
