"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.VinciCanvas = void 0;
var web_util_kit_1 = require("web-util-kit");
var util_1 = require("../util");
var static_vinci_canvas_1 = require("./static-vinci-canvas");
var VinciCanvas = /** @class */ (function (_super) {
    __extends(VinciCanvas, _super);
    function VinciCanvas(options) {
        var _this = _super.call(this, options) || this;
        _this._wrapperEl = document.createElement('div');
        // used to support drawing feature.
        _this._upperCanvas = document.createElement('canvas');
        _this._lastPointer = null;
        _this._lastDims = {};
        _this._lastAngle = null;
        _this.action = null;
        _this._onResize = function (e) {
        };
        _this._onMouseEnter = function (e) {
        };
        _this._onMouseOut = function (e) {
        };
        _this._onMouseDown = function (e) {
            console.log('mouse down');
            _this.__onMouseDown(e);
            // this._resetTransformEventData();
            var canvasElement = _this._upperCanvas;
            util_1.removeListener(canvasElement, 'mousemove', _this._onMouseMove, { passive: false });
            util_1.addListener(document, 'mousemove', _this._onMouseMove, { passive: false });
            util_1.addListener(document, 'mouseup', _this._onMouseUp);
        };
        _this._onMouseUp = function (e) {
            _this.__onMouseUp(e);
            // this._resetTransformEventData();
            var canvasElement = _this._upperCanvas;
            // 多手指触控时，最后一个手指离开时才将事件恢复
            // if (this._isMainEvent(e)) { 
            util_1.removeListener(document, 'mouseup', _this._onMouseUp);
            util_1.removeListener(document, 'mousemove', _this._onMouseMove, { passive: false });
            util_1.addListener(canvasElement, 'mousemove', _this._onMouseMove, { passive: false });
            // }
        };
        _this._onMouseWheel = function (e) {
        };
        _this._onContextMenu = function (e) {
        };
        _this._onDoubleClick = function (e) {
        };
        // real event handler
        _this.__onMouseDown = function (e) {
            var pointer = web_util_kit_1.getPointFromEvent(e, _this._lowerCanvas);
            _this._lastPointer = pointer;
            if (_this.activeShape) {
                // TODO find target corner, to decide which action
                var type = _this.activeShape.findControlCorner(pointer);
                console.log('type', type);
                if (type) {
                    _this._lastAngle = _this.activeShape.angle;
                    _this._lastDims = {
                        left: _this.activeShape.left,
                        top: _this.activeShape.top,
                        width: _this.activeShape.width,
                        height: _this.activeShape.height
                    };
                    _this.action = type;
                    return;
                }
            }
            var list = _this.shapes.slice().reverse();
            var targetShape;
            for (var i = 0; i < list.length; i++) {
                var shape = list[i];
                if (shape.isPointInPath(_this._lowerCtx, pointer)) {
                    targetShape = shape;
                    break;
                }
            }
            _this.discardActiveObject();
            if (targetShape) {
                _this.activeShape = targetShape;
                _this.action = 'move';
                _this.activeShape.active = true;
                _this.activeShape.fire('onSelected');
                _this._lastDims = {
                    left: _this.activeShape.left,
                    top: _this.activeShape.top,
                    width: _this.activeShape.width,
                    height: _this.activeShape.height
                };
            }
            else {
            }
        };
        _this._onMouseMove = function (e) {
            var pointer = web_util_kit_1.getPointFromEvent(e, _this._lowerCanvas);
            var list = _this.shapes.slice().reverse();
            var found = false;
            for (var i = 0; i < list.length; i++) {
                var shape = list[i];
                if (shape.isPointInPath(_this._lowerCtx, pointer)) {
                    found = true;
                    break;
                }
                if (shape.findControlCorner(pointer)) {
                    found = true;
                    break;
                }
            }
            if (found) {
                _this._upperCanvas.style.cursor = 'pointer';
            }
            else {
                _this._upperCanvas.style.cursor = 'default';
            }
            if (!_this.activeShape) {
                return;
            }
            if (_this.action === 'move' && _this._lastPointer && _this._lastDims) {
                _this.activeShape.move(_this._lastDims.left + (pointer.x - _this._lastPointer.x), _this._lastDims.top + (pointer.y - _this._lastPointer.y));
            }
            else if (_this.action === 'mtr' && _this._lastPointer && typeof _this._lastAngle === 'number') {
                var center = new web_util_kit_1.Point2D(_this.activeShape.translateX, _this.activeShape.translateY);
                var vector1 = _this._lastPointer.sub(center);
                var vector2 = pointer.sub(center);
                var angle = web_util_kit_1.radianToDegree(Math.atan2(vector2.y, vector2.x) - Math.atan2(vector1.y, vector1.x));
                _this.activeShape.rotate(_this._lastAngle + angle);
            }
            else if ((_this.action === 'tl' || _this.action === 'bl' || _this.action == 'br' || _this.action === 'tr' ||
                _this.action === 'ml' || _this.action === 'mb' || _this.action == 'mr' || _this.action === 'mt')
                && _this._lastDims && _this._lastPointer) {
                _this.activeShape.scaleToControlPoint(_this.action, pointer, _this._lastPointer, _this._lastDims);
            }
        };
        _this.__onMouseUp = function (e) {
            if (!_this.activeShape) {
                return;
            }
            _this._lastPointer = null;
            _this._lastDims = null;
            _this._lastAngle = null;
            _this.action = null;
        };
        _this._initDOM();
        _this._initEventListeners();
        return _this;
    }
    VinciCanvas.prototype.getElement = function () {
        return this._wrapperEl;
    };
    VinciCanvas.prototype.setDimensions = function (width, height) {
        this.width = width;
        this.height = height;
        this._lowerCanvas.width = width;
        this._lowerCanvas.height = height;
        this._upperCanvas.width = width;
        this._upperCanvas.height = height;
        this.setCssDimensions(width, height);
    };
    VinciCanvas.prototype.setCssDimensions = function (width, height) {
        web_util_kit_1.setElementStyle(this._wrapperEl, {
            width: width + "px",
            height: height + "px",
        });
        web_util_kit_1.setElementStyle(this._lowerCanvas, {
            width: width + "px",
            height: height + "px",
        });
        web_util_kit_1.setElementStyle(this._upperCanvas, {
            width: width + "px",
            height: height + "px",
        });
    };
    VinciCanvas.prototype._initDOM = function () {
        web_util_kit_1.setElementStyle(this._wrapperEl, {
            position: 'relative',
            touchAction: 'none',
            userSelect: 'none',
        });
        web_util_kit_1.setElementStyle(this._lowerCanvas, {
            position: 'absolute',
            touchAction: 'none',
            userSelect: 'none',
            left: 0,
            top: 0,
            right: 0,
            bottom: 0,
        });
        web_util_kit_1.setElementStyle(this._upperCanvas, {
            position: 'absolute',
            touchAction: 'none',
            userSelect: 'none',
            left: 0,
            top: 0,
            right: 0,
            bottom: 0,
        });
        this._wrapperEl.appendChild(this._lowerCanvas);
        this._wrapperEl.appendChild(this._upperCanvas);
        this.setDimensions(this.width, this.height);
    };
    VinciCanvas.prototype._initEventListeners = function () {
        // in case we initialized the class twice. This should not happen normally
        // but in some kind of applications where the canvas element may be changed
        // this is a workaround to having double listeners.
        this.removeListeners();
        this.addOrRemove(util_1.addListener);
    };
    VinciCanvas.prototype.addOrRemove = function (eventHelper) {
        var canvasElement = this._upperCanvas;
        eventHelper(window, 'resize', this._onResize);
        eventHelper(canvasElement, 'mousedown', this._onMouseDown);
        eventHelper(canvasElement, 'mousemove', this._onMouseMove, { passive: false });
        eventHelper(canvasElement, 'contextmenu', this._onContextMenu);
        eventHelper(canvasElement, 'mouseenter', this._onMouseEnter);
        eventHelper(canvasElement, 'mouseout', this._onMouseOut);
        eventHelper(canvasElement, 'wheel', this._onMouseWheel);
        eventHelper(canvasElement, 'dblclick', this._onDoubleClick);
    };
    VinciCanvas.prototype.removeListeners = function () {
        this.addOrRemove(util_1.removeListener);
        // if you dispose on a mouseDown, before mouse up, you need to clean document to...  
        document.removeEventListener('mouseup', this._onMouseUp);
        document.removeEventListener('mousemove', this._onMouseMove, { passive: false });
    };
    return VinciCanvas;
}(static_vinci_canvas_1.StaticVinciCanvas));
exports.VinciCanvas = VinciCanvas;
