"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ellipse = void 0;
var shape_base_1 = require("./shape-base");
var util_1 = require("../util");
var Ellipse = /** @class */ (function (_super) {
    __extends(Ellipse, _super);
    function Ellipse(options) {
        var _this = _super.call(this, options) || this;
        _this.type = 'ellipse';
        // shape params: it defines the shape
        _this.cx = 0;
        _this.cy = 0;
        _this.rx = 0;
        _this.ry = 0;
        _this.fillStyle = 'rgba(0,0,0,0.3)';
        util_1.safeMixins(_this, options);
        _this.normalize(options);
        return _this;
    }
    // dimension change --> shape change
    // from dimensions to shape 
    Ellipse.prototype.calcShape = function () {
        this.rx = this.width / 2;
        this.ry = this.height / 2;
        this.cx = this.left + this.rx;
        this.cy = this.top + this.ry;
    };
    // shape change --> dimension change
    // from shape to dimensions: left, top, width, height
    Ellipse.prototype.calcDimensions = function () {
        this.width = this.rx * 2;
        this.height = this.ry * 2;
        this.left = this.cx - this.rx;
        this.top = this.cy - this.ry;
    };
    Ellipse.prototype.render = function (ctx, vpt) {
        this.path2D = new Path2D();
        this.path2D.ellipse(this.cx - this.translateX, this.cy - this.translateY, this.rx, this.ry, 0, 0, Math.PI * 2);
        ctx.stroke(this.path2D);
        ctx.fill(this.path2D);
    };
    __decorate([
        util_1.saveContext()
    ], Ellipse.prototype, "render", null);
    return Ellipse;
}(shape_base_1.ShapeBase));
exports.Ellipse = Ellipse;
