"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Polyline = void 0;
var web_util_kit_1 = require("web-util-kit");
var shape_base_1 = require("./shape-base");
var util_1 = require("../util");
var Polyline = /** @class */ (function (_super) {
    __extends(Polyline, _super);
    function Polyline(options) {
        var _this = _super.call(this, options) || this;
        _this.type = 'polyline';
        _this.points = [];
        _this.lineWidth = 10;
        _this.lineDash = [5, 5];
        util_1.safeMixins(_this, options);
        // 以 dimension 的属性优先，以此为基准计算 shape
        _this.normalize(options);
        return _this;
    }
    // dimension change --> shape change
    // from dimension to shape
    Polyline.prototype.calcShape = function () {
        var _this = this;
        var points = this.points;
        var minX = Math.min.apply(Math, points.map(function (p) { return p.x; })) || 0;
        var minY = Math.min.apply(Math, points.map(function (p) { return p.y; })) || 0;
        var maxX = Math.max.apply(Math, points.map(function (p) { return p.x; })) || 0;
        var maxY = Math.max.apply(Math, points.map(function (p) { return p.y; })) || 0;
        var shapeWidth = (maxX - minX);
        var shapeHeight = (maxY - minY);
        var scaleX = this.width / shapeWidth;
        var scaleY = this.height / shapeHeight;
        var diff = new web_util_kit_1.Point2D(this.left, this.top).subSelf(new web_util_kit_1.Point2D(minX, minY));
        this.points.forEach(function (point) {
            point.addSelf(diff);
            point.setX(_this.left + (point.x - _this.left) * scaleX);
            point.setY(_this.top + (point.y - _this.top) * scaleY);
        });
    };
    // shape change --> dimension change
    // TODO calculate real dimension: left, top, width, height
    Polyline.prototype.calcDimensions = function () {
        var points = this.points;
        var minX = Math.min.apply(Math, points.map(function (p) { return p.x; })) || 0;
        var minY = Math.min.apply(Math, points.map(function (p) { return p.y; })) || 0;
        var maxX = Math.max.apply(Math, points.map(function (p) { return p.x; })) || 0;
        var maxY = Math.max.apply(Math, points.map(function (p) { return p.y; })) || 0;
        this.width = (maxX - minX);
        this.height = (maxY - minY);
        this.left = minX;
        this.top = minY;
    };
    Polyline.prototype.render = function (ctx, vpt) {
        var _this = this;
        this.path2D = new Path2D();
        this.points.forEach(function (point, index) {
            if (index === 0) {
                _this.path2D.moveTo(point.x - _this.translateX, point.y - _this.translateY);
            }
            _this.path2D.lineTo(point.x - _this.translateX, point.y - _this.translateY);
        });
        ctx.stroke(this.path2D);
    };
    __decorate([
        util_1.saveContext()
    ], Polyline.prototype, "render", null);
    return Polyline;
}(shape_base_1.ShapeBase));
exports.Polyline = Polyline;
