import { Matrix2X3Array, TRANSFORM_OPTIONS, Point2D } from 'web-util-kit';
import { Control } from '../auxiliary/control';
import { StaticVinciCanvas } from '../canvas/static-vinci-canvas';
import { ShapeEvent } from '../event';
export declare abstract class ShapeBase extends ShapeEvent {
    readonly type: string;
    left: number;
    top: number;
    private _width;
    private _height;
    set width(nextVal: number);
    get width(): number;
    set height(nextVal: number);
    get height(): number;
    private _centerXRatio;
    private _centerYRatio;
    set centerXRatio(nextVal: number);
    get centerXRatio(): number;
    set centerYRatio(nextVal: number);
    get centerYRatio(): number;
    lineWidth: number;
    strokeWidth: number;
    fillStyle: string;
    strokeStyle: string;
    lineDash: number[];
    angle: number;
    skewX: number;
    skewY: number;
    private _scaleX;
    private _scaleY;
    set scaleX(val: number);
    get scaleX(): number;
    set scaleY(val: number);
    get scaleY(): number;
    get translateX(): number;
    get translateY(): number;
    flipX: boolean;
    flipY: boolean;
    path2D: Path2D;
    active: boolean;
    control: Control;
    other: any;
    vinci: StaticVinciCanvas | null;
    constructor(options?: any);
    set(key: string, val: any): void;
    set(options?: object): void;
    setVinci(vinci: StaticVinciCanvas): void;
    getTransformOptions(): TRANSFORM_OPTIONS;
    getTransformMatrix2X3Array(): Matrix2X3Array;
    abstract calcShape(): any;
    abstract calcDimensions(): any;
    normalize(nextOptions?: any): void;
    calcControls(): void;
    abstract render(ctx: CanvasRenderingContext2D, vpt: any): any;
    renderControls(ctx: CanvasRenderingContext2D, vpt: Matrix2X3Array): void;
    isPointInPath(ctx: CanvasRenderingContext2D, point: any): boolean;
    rotate(angle: number): void;
    move(x: number, y: number): void;
    scaleToControlPoint(pointType: string, pointer: Point2D, lastPointer: Point2D, lastDims: any): void;
    findControlCorner(pointer: Point2D): any;
    upward(): void;
    downward(): void;
    toFront(): void;
    toBack(): void;
}
