"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShapeBase = void 0;
var util_1 = require("../util");
var web_util_kit_1 = require("web-util-kit");
var control_1 = require("../auxiliary/control");
var event_1 = require("../event");
var ShapeBase = /** @class */ (function (_super) {
    __extends(ShapeBase, _super);
    function ShapeBase(options) {
        var _this = _super.call(this) || this;
        _this.type = 'shape-base';
        // dimensions of the shape
        _this.left = 0;
        _this.top = 0;
        _this._width = 0;
        _this._height = 0;
        // center point relative ratio
        _this._centerXRatio = 0.5;
        _this._centerYRatio = 0.5;
        // drawing style
        _this.lineWidth = 2;
        _this.strokeWidth = 2;
        _this.fillStyle = 'blue';
        _this.strokeStyle = 'yellow';
        _this.lineDash = [];
        // more style put here
        // transform
        // 角度单位
        _this.angle = 0;
        _this.skewX = 0;
        _this.skewY = 0;
        _this._scaleX = 1;
        _this._scaleY = 1;
        _this.flipX = false;
        _this.flipY = false;
        _this.path2D = new Path2D();
        _this.active = false;
        // controll points 
        _this.control = new control_1.Control();
        // extra info stored in shape for other usage
        _this.other = {};
        _this.vinci = null;
        util_1.safeMixins(_this, options);
        return _this;
    }
    Object.defineProperty(ShapeBase.prototype, "width", {
        get: function () { return this._width; },
        set: function (nextVal) {
            if (nextVal < 0) {
                return;
            }
            this._width = nextVal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "height", {
        get: function () { return this._height; },
        set: function (nextVal) {
            if (nextVal < 0) {
                return;
            }
            this._height = nextVal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "centerXRatio", {
        get: function () { return this._centerXRatio; },
        set: function (nextVal) {
            if (nextVal < 0 || nextVal > 1) {
                return;
            }
            this._centerXRatio = nextVal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "centerYRatio", {
        get: function () { return this._centerYRatio; },
        set: function (nextVal) {
            if (nextVal < 0 || nextVal > 1) {
                return;
            }
            this._centerYRatio = nextVal;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "scaleX", {
        get: function () {
            return this._scaleX;
        },
        set: function (val) {
            if (val < 0) {
                return;
            }
            this._scaleX = val;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "scaleY", {
        get: function () {
            return this._scaleY;
        },
        set: function (val) {
            if (val < 0) {
                return;
            }
            this._scaleY = val;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "translateX", {
        get: function () {
            return this.left + this.width * this.centerXRatio;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ShapeBase.prototype, "translateY", {
        get: function () {
            return this.top + this.height * this.centerYRatio;
        },
        enumerable: false,
        configurable: true
    });
    ShapeBase.prototype.set = function (arg1, arg2) {
        var _a;
        var nextOpts = {};
        if (typeof arg1 === 'string' && arg2 !== undefined) {
            nextOpts = (_a = {},
                _a[arg1] = arg2,
                _a);
        }
        else if (arg1 && typeof arg1 === 'object') {
            nextOpts = __assign({}, arg1);
        }
        util_1.safeMixins(this, nextOpts);
        this.normalize(nextOpts);
    };
    ShapeBase.prototype.setVinci = function (vinci) {
        this.vinci = vinci;
        this.dispose();
        var renderer = function () { return vinci.requestRender(); };
        this.onAdded(renderer);
        this.onRemoved(renderer);
        this.onSelected(renderer);
        this.onUnSelected(renderer);
        this.onModified(renderer);
    };
    ShapeBase.prototype.getTransformOptions = function () {
        return {
            angle: this.angle,
            skewX: this.skewX,
            skewY: this.skewY,
            scaleX: this.scaleX,
            scaleY: this.scaleY,
            flipX: this.flipX,
            flipY: this.flipY,
            translateX: this.translateX,
            translateY: this.translateY,
        };
    };
    ShapeBase.prototype.getTransformMatrix2X3Array = function () {
        return web_util_kit_1.composeMatrix2X3({
            angle: this.angle,
            skewX: this.skewX,
            skewY: this.skewY,
            scaleX: this.scaleX,
            scaleY: this.scaleY,
            flipX: this.flipX,
            flipY: this.flipY,
            translateX: this.translateX,
            translateY: this.translateY,
        });
    };
    ShapeBase.prototype.normalize = function (nextOptions) {
        if (util_1.hasDimsProp(nextOptions)) {
            this.calcShape();
        }
        this.calcDimensions();
    };
    ShapeBase.prototype.calcControls = function () {
        this.control.calculate(this.width, this.height);
    };
    ShapeBase.prototype.renderControls = function (ctx, vpt) {
        if (!this.active) {
            return;
        }
        this.calcControls();
        // TODO check is control visible
        ctx.strokeStyle = 'blue';
        ctx.setLineDash([4, 4]);
        ctx.strokeRect(this.left - this.translateX, this.top - this.translateY, this.width, this.height);
        ctx.beginPath();
        var mt = this.control.getPoint('mt');
        var mtr = this.control.getPoint('mtr');
        ctx.moveTo(mt.x, mt.y);
        ctx.lineTo(mtr.x, mtr.y);
        ctx.stroke();
        ctx.fillStyle = 'red';
        this.control.getAllVisiblePoints().forEach(function (cp) {
            var point = cp.point;
            ctx.beginPath();
            ctx.arc(point.x, point.y, 6, 0, Math.PI * 2);
            ctx.fill();
        });
    };
    ShapeBase.prototype.isPointInPath = function (ctx, point) {
        if (ctx.isPointInPath(this.path2D, point.x, point.y)) {
            return true;
        }
        return false;
    };
    ShapeBase.prototype.rotate = function (angle) {
        this.angle = angle;
    };
    ShapeBase.prototype.move = function (x, y) {
        this.left = x;
        this.top = y;
        this.calcShape();
    };
    ShapeBase.prototype.scaleToControlPoint = function (pointType, pointer, lastPointer, lastDims) {
        var inverseMatrix = web_util_kit_1.invertMatrix2X3(this.getTransformMatrix2X3Array());
        pointer = web_util_kit_1.transformPoint2D(pointer, inverseMatrix);
        lastPointer = web_util_kit_1.transformPoint2D(lastPointer, inverseMatrix);
        var diff = pointer.sub(lastPointer);
        if (pointType === 'tl') {
            this.left = pointer.x + this.translateX;
            this.top = pointer.y + this.translateY;
            this.width = lastDims.width - diff.x;
            this.height = lastDims.height - diff.y;
        }
        else if (pointType === 'tr') {
            this.left = pointer.x + this.translateX - this.width;
            this.top = pointer.y + this.translateY;
            this.width = lastDims.width + diff.x;
            this.height = lastDims.height - diff.y;
        }
        else if (pointType === 'bl') {
            this.left = pointer.x + this.translateX;
            this.top = pointer.y + this.translateY - this.height;
            this.width = lastDims.width - diff.x;
            this.height = lastDims.height + diff.y;
        }
        else if (pointType === 'br') {
            this.left = pointer.x + this.translateX - this.width;
            this.top = pointer.y + this.translateY - this.height;
            this.width = lastDims.width + diff.x;
            this.height = lastDims.height + diff.y;
        }
        else if (pointType === 'ml') {
            this.left = pointer.x + this.translateX;
            this.width = lastDims.width - diff.x;
        }
        else if (pointType === 'mr') {
            this.width = lastDims.width + diff.x;
        }
        else if (pointType === 'mt') {
            this.top = pointer.y + this.translateY;
            this.height = lastDims.height - diff.y;
        }
        else if (pointType === 'mb') {
            this.height = lastDims.height + diff.y;
        }
        this.calcShape();
    };
    ShapeBase.prototype.findControlCorner = function (pointer) {
        return this.control.findType(pointer, this.getTransformMatrix2X3Array());
    };
    // TODO: layer index operation
    ShapeBase.prototype.upward = function () {
        if (!this.vinci) {
            return;
        }
        this.vinci.upwardObject(this);
    };
    ShapeBase.prototype.downward = function () {
        if (!this.vinci) {
            return;
        }
        this.vinci.downwardObject(this);
    };
    ShapeBase.prototype.toFront = function () {
        if (!this.vinci) {
            return;
        }
        this.vinci.toFrontObject(this);
    };
    ShapeBase.prototype.toBack = function () {
        if (!this.vinci) {
            return;
        }
        this.vinci.toBackObject(this);
    };
    __decorate([
        util_1.needRendering()
    ], ShapeBase.prototype, "set", null);
    __decorate([
        util_1.saveContext()
    ], ShapeBase.prototype, "renderControls", null);
    __decorate([
        util_1.saveContext()
    ], ShapeBase.prototype, "isPointInPath", null);
    __decorate([
        util_1.needRendering()
    ], ShapeBase.prototype, "rotate", null);
    __decorate([
        util_1.needRendering()
    ], ShapeBase.prototype, "move", null);
    __decorate([
        util_1.needRendering()
    ], ShapeBase.prototype, "scaleToControlPoint", null);
    return ShapeBase;
}(event_1.ShapeEvent));
exports.ShapeBase = ShapeBase;
