"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Source = void 0;
var web_util_kit_1 = require("web-util-kit");
var util_1 = require("../util");
var rect_1 = require("./rect");
var Source = /** @class */ (function (_super) {
    __extends(Source, _super);
    function Source(options) {
        var _this = _super.call(this, options) || this;
        _this.type = 'source';
        _this.originalWidth = 0;
        _this.originalHeight = 0;
        _this._cacheCanvas = document.createElement('canvas');
        _this._cacheCtx = _this._cacheCanvas.getContext('2d');
        util_1.safeMixins(_this, options);
        _this.normalize(options);
        return _this;
    }
    Source.prototype.loadFromSource = function (source) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(source instanceof HTMLImageElement)) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, web_util_kit_1.loadFromImage(source)];
                    case 1:
                        _a.source = _b.sent();
                        this.width = this.source.width;
                        this.height = this.source.height;
                        this.originalWidth = this.source.width;
                        this.originalHeight = this.source.height;
                        this._cacheCanvas.width = this.source.width;
                        this._cacheCanvas.height = this.source.height;
                        this._cacheCtx.drawImage(this.source, 0, 0);
                        _b.label = 2;
                    case 2:
                        if (source instanceof HTMLCanvasElement) {
                            this.source = source;
                            this.width = this.source.width;
                            this.height = this.source.height;
                            this.originalWidth = this.source.width;
                            this.originalHeight = this.source.height;
                            this._cacheCanvas.width = this.source.width;
                            this._cacheCanvas.height = this.source.height;
                            this._cacheCtx.drawImage(this.source, 0, 0);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Source.prototype.render = function (ctx, vpt) {
        if (!this.source) {
            return;
        }
        ctx.drawImage(this._cacheCanvas, 0, 0, this._cacheCanvas.width, this._cacheCanvas.height, this.x - this.translateX, this.y - this.translateY, this.width, this.height);
        this.path2D = new Path2D();
        this.path2D.rect(this.x - this.translateX, this.y - this.translateY, this.width, this.height);
    };
    Source.prototype.isPointInPath = function (ctx, point) {
        if (!ctx.isPointInPath(this.path2D, point.x, point.y)) {
            return false;
        }
        var inverseMatrix = web_util_kit_1.invertMatrix2X3(this.getTransformMatrix2X3Array());
        var realPointer = web_util_kit_1.transformPoint2D(point, inverseMatrix).addSelf(new web_util_kit_1.Point2D(this.translateX - this.x, this.translateY - this.y));
        realPointer.setX(realPointer.x * this.originalWidth / this.width);
        realPointer.setY(realPointer.y * this.originalHeight / this.height);
        console.log(realPointer.x, realPointer.y, this.width, this.height, this.scaleX, this.scaleY);
        if (web_util_kit_1.isTransparent(this._cacheCtx, realPointer.x, realPointer.y, 1)) {
            return false;
        }
        return true;
    };
    __decorate([
        util_1.saveContext()
    ], Source.prototype, "render", null);
    __decorate([
        util_1.saveContext()
    ], Source.prototype, "isPointInPath", null);
    return Source;
}(rect_1.Rect));
exports.Source = Source;
