"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeMixins = exports.getRenderingProperties = exports.hasDimsProp = exports.needRendering = exports.saveContext = exports.removeListener = exports.addListener = void 0;
var util_kit_1 = require("util-kit");
var const_1 = require("./const");
__exportStar(require("./const"), exports);
var createDecorator = util_kit_1.decorators.createDecorator;
var deepClone = util_kit_1.objects.deepClone, equals = util_kit_1.objects.equals;
function addListener(element, eventName, handler, options) {
    element && element.addEventListener(eventName, handler, options);
}
exports.addListener = addListener;
;
function removeListener(element, eventName, handler, options) {
    element && element.removeEventListener(eventName, handler, options);
}
exports.removeListener = removeListener;
;
// export function isMainEvent(evt: Event) {
//  if (evt.isPrimary === true) {
//    return true;
//  }
//  if (evt.isPrimary === false) {
//    return false;
//  }
//  if (evt.type === 'touchend' && evt.touches.length === 0) {
//    return true;
//  }
//  if (evt.changedTouches) {
//    return evt.changedTouches[0].identifier === this.mainTouchId;
//  }
//  return true;
// }
function saveContext() {
    return createDecorator(function (fn, key) {
        return function (ctx, vpt) {
            if (!(ctx instanceof CanvasRenderingContext2D)) {
                throw new Error('failed to get CanvasRenderingContext2D');
            }
            this.normalize();
            ctx.save();
            ctx.lineWidth = this.lineWidth;
            ctx.fillStyle = this.fillStyle;
            ctx.strokeStyle = this.strokeStyle;
            ctx.setLineDash(this.lineDash);
            ctx.setTransform.apply(ctx, this.getTransformMatrix2X3Array());
            var res = fn.apply(this, arguments);
            ctx.restore();
            return res;
        };
    });
}
exports.saveContext = saveContext;
function needRendering() {
    return createDecorator(function (fn, key) {
        return function () {
            var prev = getRenderingProperties(this);
            var res = fn.apply(this, arguments);
            var current = getRenderingProperties(this);
            if (!equals(current, prev)) {
                this.fire('onModified');
            }
            return res;
        };
    });
}
exports.needRendering = needRendering;
function hasDimsProp(obj) {
    if (!obj) {
        return false;
    }
    for (var i = 0; i < const_1.DIMS_PROPERTIES.length; i++) {
        var prop = const_1.DIMS_PROPERTIES[i];
        if (obj[prop] && typeof obj[prop] === 'number') {
            return true;
        }
    }
    return false;
}
exports.hasDimsProp = hasDimsProp;
function getRenderingProperties(obj) {
    var res = {};
    const_1.RENDERING_PROPERTIES.forEach(function (prop) {
        res[prop] = deepClone(obj[prop]);
    });
    return res;
}
exports.getRenderingProperties = getRenderingProperties;
function safeMixins(target, source, backup) {
    if (backup === void 0) { backup = 'other'; }
    if (!source || !target) {
        return;
    }
    target[backup] = target[backup] || {};
    var keys = Object.keys(source);
    keys.forEach(function (key) {
        if (typeof target[key] === 'undefined') {
            target[backup][key] = source[key];
        }
        else {
            target[key] = source[key];
        }
    });
    var otherKeys = Object.keys(target[backup]);
    otherKeys.forEach(function (otherKey) {
        if (typeof target[otherKey] !== 'undefined') {
            delete target[backup][otherKey];
        }
    });
}
exports.safeMixins = safeMixins;
